#ifndef _IMAGESAVEDIALOG_H_
#define _IMAGESAVEDIALOG_H_

#include <boost/shared_ptr.hpp>
 
#include <QDialog>
#include <QDir>

#include "qui/seqbrowser/SequenceBrowser.hpp"
#include "qui/seqbrowser/SequenceBrowserWidget.hpp"
#include "qui/seqbrowser/ScrollableSequenceBrowser.hpp"

class ImageScaler;
class QLabel;
class QPixmap;
class QPushButton;
class QGLWidget;

class ImageSaveDialog : public QDialog
{
  Q_OBJECT

public:
  ImageSaveDialog(boost::shared_ptr<QDir> default_dir_, 
		  ScrollableSequenceBrowser *scrollSeqBrowser = 0,
		  QWidget *parent = 0);
  QDir defaultDir() const;
  
public slots:
  void accept();
  void reject();
  void setSize(int width, int height);

private:
  //! prompt user for file name and save image, if (endDialog) close dialog
  /** if endDialog is true, we should close the dialog box,
   *  otherwise, keep the dialog box. (In case the user canceled out
   *  of save as.
   */  
  void savePixmap(bool &endDialog);
  QSize getOpenGlPixmapSize();
  QPixmap renderOpenGlPixmap();
  
  boost::shared_ptr<QDir> default_dir;
  ImageScaler *imageScaler;
  QPushButton *saveButton;
  QPushButton *cancelButton;

  SequenceBrowser glwidget;
};

#endif 
