#ifndef _THRESHOLD_WIDGET_H_ 
#define _THRESHOLD_WIDGET_H_

#include <QHBoxLayout>
#include <QLabel>
#include <QSpinBox>
#include <QWidget>

class ThresholdWidget : public QWidget
{
  Q_OBJECT 

public: 
  ThresholdWidget(QWidget *parent = 0, int min=20, int max=30);
  
  //! is the widget in read only mode
  bool isReadOnly() const;
  //! set the widget to specified read only state
  void setReadOnly(bool);

  //! return min_threshold/max_threshold
  double min_ratio() const;
  //! return current_threshold/maximum_threshold
  double ratio() const;
  //! return our current threshold
  int threshold() const;
  //! update percent threshold
  void updatePercentThreshold();

public slots:
  void setBasepairThreshold(int threshold);
  //void setPercentThreshold(int percent_threshold);
  //! set the min and max base pair range
  void setRange(int min, int max);

signals:
  //! the current number of base pairs needed for a window of conservation
  void thresholdChanged(int new_threshold);

protected:
  void setupWidgets();
  QHBoxLayout *layout;
  QSpinBox *basepair_spinner;
  QLabel *window_size_label;
  QLabel *percent_label;

  int cur_bp_threshold;
  int cur_percent_threshold;
};
const int threshold_max_display_digits = 2;

#endif
